#ifndef	__TL_FSDEFS_H
#define	__TL_FSDEFS_H

#ifdef __cplusplus
extern "C" {
#endif

/* user-definable configuration */
#if 1
#define	DEBUG(X)	X
#else
#define	DEBUG(X)	/* nothing */
#endif

#define	FS_FAT	1
#define	FS_EXT2	1
/* #define	FILE_TIMES	1 */
/* #define	USE_HEAP	1 */









/* this is not yet implemented */
/* #define	FILE_IDS	1 */

#if defined(__TURBOC__)
#if __TURBOC__<0x0300
#undef DEBUG
#define	DEBUG(X)	/* nothing */
#endif
#endif

/* max length of filename */
#define	MAX_NAME_LEN	256 /* xxx */

#if defined(__TURBOC__)
/* huge pointers are buggy for Turbo C 3.0,
OK for Turbo C 2.0 and Borland C 3.1 */
#define	HUGE		far
#else
#define	HUGE		/* nothing */
#endif

#ifndef NULL
#define NULL	0	/* Turbo C 2.0 */
#endif

#if !defined(USE_HEAP)
/* 20 bytes for FAT, 16 bytes for ext2 */
#define	MOUNT_INFO_SIZE	20
/* 2 bytes for FAT, 60 bytes for ext2 */
#define	FILE_INFO_SIZE	64
#endif

/* these assume sizeof(short)==2 and sizeof(long)==4
and little-endian CPU like x86 */
#define	read_le16(X)	*(unsigned short *)(X)
#define	read_le32(X)	*(unsigned long *)(X)
#define	write_le16(X,V)	*(unsigned short *)(X) = (V)
#define	write_le32(X,V)	*(unsigned long *)(X) = (V)

typedef long	pos_t;

typedef struct
{
	unsigned char dev_num;		/* INT 13h drv num */
	unsigned char heads, sectors;	/* floppy and CHS HD only */
	unsigned short bps;		/* bytes per sector, usu. 512 */
	signed char part_num;		/* HD only, 0-3 or -1 for entire disk */
	unsigned char part_type;	/* read from MBR or 0 for unknown */
	unsigned long part_start;	/* LBA of first sector of partition */
	unsigned long part_size;	/* or disk size */
	unsigned use_lba : 1;
} drv_t;

typedef struct
{
	drv_t *drv;
	const struct _fs_info *fs_info;
	char mount_pt[MAX_NAME_LEN];
#if defined(USE_HEAP)
	void *fs_mount_info;
#else
	unsigned char fs_mount_info[MOUNT_INFO_SIZE];
#endif
} mount_t;

typedef struct
{
	pos_t pos;
	mount_t *mount;
	char is_open;
#if defined(FILE_TIMES)
	unsigned long st_atime, st_mtime, st_ctime;
#endif
/* the rest is the same as dirent_t */
#if defined(USE_HEAP)
	void *fs_file_info;
#else
	unsigned char fs_file_info[FILE_INFO_SIZE];
#endif
	char name[MAX_NAME_LEN];
	unsigned short mode;
	pos_t size;
} file_t;

typedef struct
{
#if defined(USE_HEAP)
	void *fs_file_info;
#else
	unsigned char fs_file_info[FILE_INFO_SIZE];
#endif
	char name[MAX_NAME_LEN];
	unsigned short mode;
	pos_t size;
} dirent_t;

/* xxx - these should be in dirent.h,
but I can't figure out how to do things without
.h files #include'ing other .h files */
struct dirent
{
	char d_name[MAX_NAME_LEN];
};

typedef struct
{
	file_t *file;
	struct dirent ent;
} DIR;

DIR * opendir(char *path);
struct dirent *readdir(DIR *dir);
int closedir(DIR *dir);
void rewinddir(DIR *dir);





typedef struct _fs_info
{
	const char *name;
	pos_t (*read)(file_t *file, unsigned char HUGE *buf, pos_t count);
	int (*readdir)(file_t *file, struct dirent *ent);
	int (*find)(file_t *file, const char *name,
		const unsigned short name_len);
} fs_info_t;

#ifdef __cplusplus
}
#endif

#endif
